/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Window.xs. Do not edit this file, edit Window.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Window.xs"

/* 
   PGPLOT.xs  

   A few routines in C to speed up PDL access to PGPLOT primitives.

*/

#include "EXTERN.h"   /* std perl include */
#include "perl.h"     /* std perl include */
#include "XSUB.h"     /* XSUB include */
#include "ppport.h"   /* for backwards comaptibility */

struct PGPLOT_function_handle {
   I32 binversion;
   void (*cpgmove) (float x, float y);
   void (*cpgdraw) (float x, float y);
   void (*cpgqcir) (int *icilo, int *icihi);
   void (*cpgsci)  (int ci);
   void (*cpgpt1)  (float x, float y, int sym);                                 
};

typedef struct PGPLOT_function_handle PGPLOT_function_handle;

static I32 PGPLOT_structure_version = 20000302;  /* The date the PGPLOT structure changed */
static PGPLOT_function_handle  *myhandle;
SV *ptr;

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 43 "Window.c"

XS(XS_PDL__Graphics__PGPLOT__Window_pggapline); /* prototype to pass -Wmissing-prototypes */
XS(XS_PDL__Graphics__PGPLOT__Window_pggapline)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "PDL::Graphics::PGPLOT::Window::pggapline", "n, msgval, xpts, ypts");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	n = (int)SvIV(ST(0));
	float	msgval = (float)SvNV(ST(1));
	float *	xpts = (float *)(SvPV(SvRV(ST(2)), PL_na));
	float *	ypts = (float *)(SvPV(SvRV(ST(3)), PL_na));
#line 38 "Window.xs"
    { int i;
      int start = 0;
      while (xpts[start] == msgval) start++;  /* make sure we have a good starting point */
      myhandle->cpgmove (xpts[start], ypts[start]);
      for (i=start+1;i<n;i++) {
        if (ypts[i] == msgval) {
           /* check we are not at end of array and we don't move to a missing value */
           if (i != n-1 && ypts[i+1] != msgval) { 
             myhandle->cpgmove (xpts[i+1], ypts[i+1]);
           }
        }
        else { 
          myhandle->cpgdraw (xpts[i], ypts[i]);	
        }
      }
    }
#line 78 "Window.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PDL__Graphics__PGPLOT__Window_pgcolorpnts); /* prototype to pass -Wmissing-prototypes */
XS(XS_PDL__Graphics__PGPLOT__Window_pgcolorpnts)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "PDL::Graphics::PGPLOT::Window::pgcolorpnts", "n, x, y, z, sym");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	n = (int)SvIV(ST(0));
	float *	x = (float *)(SvPV(SvRV(ST(1)), PL_na));
	float *	y = (float *)(SvPV(SvRV(ST(2)), PL_na));
	float *	z = (float *)(SvPV(SvRV(ST(3)), PL_na));
	int	sym = (int)SvIV(ST(4));
#line 65 "Window.xs"
    { 
      /* find range of color pallette */
      int icilo, icihi, i, cirange, ci;
      float minz, maxz, zrange;

      /* If the structure read from the PGPLOT module is too old */
      if (myhandle->binversion < PGPLOT_structure_version) {
	char msg[128];
        sprintf (msg, "This function requires PGPLOT with a structure version at least %d.\nPlease upgrade your PGPLOT package.", 
                       PGPLOT_structure_version);

        Perl_croak(aTHX_ msg);
      }

      myhandle->cpgqcir(&icilo, &icihi);

      /* find min and max values of zpts variable */
      minz =  9.99e30;
      maxz = -9.99e30;
      for (i=0;i<n;i++) {
	if (z[i] < minz) minz = z[i];
	if (z[i] > maxz) maxz = z[i];
      }

      /* determine range of available z indices and range of input 'z' values */
      cirange = icihi - icilo;
      zrange  = maxz  - minz;

      /* printf ("cilo = %d, cihi = %d\n", icilo, icihi); */

      /* for each input point, compute a scaled color index and plot the point */
      for (i=0;i<n;i++) {
	ci = (int)(icilo + (z[i] - minz) * (float)(cirange/zrange)); 
	/* printf ("x = %f, y = %f, ci = %d\n", x[i], y[i], ci); */
	myhandle->cpgsci(ci);
	myhandle->cpgpt1(x[i], y[i], sym);
      }
    }
#line 140 "Window.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_PDL__Graphics__PGPLOT__Window); /* prototype to pass -Wmissing-prototypes */
XS(boot_PDL__Graphics__PGPLOT__Window)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("PDL::Graphics::PGPLOT::Window::pggapline", XS_PDL__Graphics__PGPLOT__Window_pggapline, file);
        newXS("PDL::Graphics::PGPLOT::Window::pgcolorpnts", XS_PDL__Graphics__PGPLOT__Window_pgcolorpnts, file);

    /* Initialisation Section */

#line 107 "Window.xs"

	/* Get pointer to structure of core shared C routines */
	ptr = perl_get_sv("PGPLOT::HANDLE",FALSE);  /* SV* value */
#ifndef aTHX_
#define aTHX_
#endif
	if (ptr==NULL)
	  Perl_croak(aTHX_ "This module requires PGPLOT version 2.16 or later.\nPlease install/upgrade PGPLOT (see the PDL/DEPENDENCIES file).");
	myhandle = INT2PTR(PGPLOT_function_handle*,SvIV( ptr ));  

#line 178 "Window.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

